routes/web.php
<?php
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Website
Route::group(['namespace' => 'Website'], function () {

    Route::get('/', 'WebsiteController@get_index')->name('index');
    Route::get('/product', 'WebsiteController@get_product')->name('product');
    Route::get('policy', 'WebsiteController@get_policy')->name('policy');
    Route::get('terms', 'WebsiteController@get_terms')->name('terms');
    //products
    Route::get('products', 'ProductsController@index')->name('products.web.index');
    Route::get('products/{product}', 'ProductsController@show')->name('products.web.show');
    Route::get('autocomplete', 'ProductsController@autocomplete')->name('products.web.autocomplete');

    //category
    Route::get('categories/{category}/products', 'ProductsController@index_category')->name('products.categories');
    Route::get('categories/{category}', 'CatgoriesController@show')->name('categories.web.show');

    //cart
    Route::get('cart','CartContoller@index')->name('cart.index');
    Route::post('cart/{product}/store','CartContoller@store')->name('cart.store');
    Route::delete('cart/empty','CartContoller@empty')->name('cart.empty');
    Route::delete('cart/{product}/remove','CartContoller@remove')->name('cart.remove');
    Route::get('register', 'ClientController@create')->name('web.client.create');
    Route::post('register/store', 'ClientController@store')->name('web.client.store');

    // Auth::routes()
    Route::group(['namespace' => 'Auth'], function() {
        Route::get('login', 'LoginController@showLoginForm')->name('web.login');
        Route::post('login', 'LoginController@login')->name('web.login.store');
        Route::post('logout', 'LoginController@logout')->name('web.logout');
        Route::get('forget','ForgetPasswordController@index')->name('web.forget');
        Route::post('forget','ForgetPasswordController@forget')->name('web.forget_password');
        Route::get('password/reset/{token}', 'ForgetPasswordController@showResetForm')->name('password.reset');
        Route::post('password/reset', 'ForgetPasswordController@reset')->name('password.update');

    });

    Route::group(['middleware' => 'auth.buyer'], function () {
        //addresses
        Route::get('MyAddresses/index', 'AddressesController@index')->name('web.myaddresses.index');
        Route::get('MyAddresses/create', 'AddressesController@create')->name('web.myaddresses.create');
        Route::get('MyAddresses/{address}/edit', 'AddressesController@edit')->name('web.myaddresses.edit');
        Route::put('MyAddresses/{address}/update', 'AddressesController@update')->name('web.myaddresses.update');
        Route::delete('MyAddresses/{address}/destroy', 'AddressesController@destroy')->name('web.myaddresses.destroy');
        Route::post('MyAddresses/store', 'AddressesController@store')->name('web.myaddresses.store');

        //orders
        Route::get('MyOrders', 'OrdersController@index')->name('web.myorders.index');
        Route::get('MyOrders/{order}/order', 'OrdersController@show')->name('web.myorders.show');




        Route::get('MyWishlists', 'WishlistsController@index')->name('web.mywishlists');
        Route::get('MyWishlists/create', 'WishlistsController@create')->name('web.mywishlists.create');
        Route::post ('MyWishlists/add', 'WishlistsController@add')->name('web.mywishlists.add');
        Route::put ('MyWishlists/update', 'WishlistsController@update')->name('web.mywishlists.update');
        Route::delete('MyWishlists/{wishlist_product}/remove', 'WishlistsController@remove')->name('web.mywishlists.remove');

        Route::delete('MyWishlists/{wishlist}/destroy', 'WishlistsController@destroy')->name('web.mywishlists.destroy');
        Route::post('MyWishlists/store', 'WishlistsController@store')->name('web.mywishlists.store');

        Route::post('checkout', 'OrdersController@get_checkout')->name('web.checkout');
        Route::post('checkout/place_order/{order}', 'OrdersController@place_order')->name('web.orders.place_order');

    });

});


//Admin
Route::group(['prefix' => 'admin'], function () {


    // Auth::routes()
    Route::group(['namespace' => 'Auth'], function() {
        Route::get('login', 'LoginController@showLoginForm')->name('login');
        Route::post('login', 'ConfirmPasswordController@login');
        Route::post('logout', 'LoginController@logout')->name('logout');
        Route::post('reset', 'ResetPasswordController@reset')->name('password.request');
    });

    Route::group(['middleware' => 'auth', 'namespace' => 'Admin'], function () {

        // Dashboard
        Route::get('dashboard', 'DashboardController@index')->name('dashboard.index');
        // All
        Route::resource('users', 'UserController');
        Route::post('users/create/fetch', 'UserController@fetch_category_data')->name('category.fetch');

        // Clients
        Route::resource('clients', 'ClientController');
        //Cities
        Route::resource('cities', 'CityController');
        // Stores
        Route::resource('stores', 'StoreController');
        Route::resource('stores/{store}/tags', 'StoreTagController');
        Route::put('stores/{store}/cover', 'StoreController@update_cover')->name('stores.update_cover');
        Route::resource('stores/{store}/offers', 'StoreOfferController');
        // products
        Route::resource('stores/{store}/products', 'ProductsController');
        Route::resource('stores/{store}/products/{product}/specs', 'SpecsController');
        Route::get('products','ProductsController@all_index')->name('all_products.index');
        Route::put('stores/{store}/products/{product}/to_review','ProductsController@to_review')->name('products.to_review');
        Route::put('stores/{store}/products/{product}/to_approve','ProductsController@to_approve')->name('products.to_approve');
        Route::put('stores/{store}/products/{product}/to_reject','ProductsController@to_reject')->name('products.to_reject');
        Route::put('stores/{store}/products/{product}/to_offline','ProductsController@to_offline')->name('products.to_offline');

        //offers
        Route::resource('stores/{store}/products/{product}/offers', 'ProductOffersController');
        ////
        Route::put('stores/{store}/products/{product}/update_image', 'ProductsController@update_image')->name('products.update_image');
        Route::post('stores/{store}/products/{product}/add_image', 'ProductsController@add_image')->name('products.add_image');
        Route::delete('stores/{store}/products/{product}/product_image/{product_image}', 'ProductsController@remove_image')->name('products.remove_image');
        //Orders
        Route::resource('orders', 'OrderController');
        Route::put('orders/{order}/confirm','OrderController@confirm')->name('orders.confirm');
        Route::put('orders/{order}/shipped','OrderController@shipped')->name('orders.shipped');
        Route::get('orders/{order}/print','PrintController@prnpriview')->name('orders.print');

        Route::put('orders/{order}/in_shipping','OrderController@in_shipping')->name('orders.in_shipping');

        //shipments
        Route::get('shipments','ShipmentsController@index')->name('shipments.index');
        Route::put('shipments/{shipment}','ShipmentsController@confirm')->name('shipments.confirm');
        //reviews
        Route::resource('stores/{store}/reviews', 'ProductsController');
        //Banners
        Route::resource('banners','BannerController');
        // Categories
        Route::resource('categories', 'CategoryController');
        Route::resource('categories/{category}/subs', 'SubCategoryController');
        // Notifications
        Route::resource('notifications', 'NotificationController', ['only' => ['index', 'create', 'store']]);
        //Tags Presets
        Route::resource('tags_presets', 'TagsPresetsController');
        Route::resource('tags_presets/{tags_preset}/tags_params', 'TagsPresetsParametersController');


    });

});

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Kyslik\ColumnSortable\Sortable;

class Product extends Model
{
    //
    use Sortable;

    const STATUS_ONLINE=1;
    const STATUS_INREVIEW=2;
    const STATUS_REJECTED=3;
    const STATUS_OFFLINE=4;
    const STATUS_DRAFT=5;

    public $sortable = ['id','name','sub_category_id','status','rate','ordered','store_id','stock','price','created_at'];
    public $sortableAs = ['reviews_count'];

    public function reviews()
    {
        return $this->hasMany('App\ProductReview', 'product_id');
    }
    public function specs()
    {
        return $this->hasMany('App\ProductSpec', 'product_id');
    }
    public function getImageAttribute($value)
    {
        return asset('files/products/images/'.$value);
    }
    public function sub_category()
    {
        return $this->belongsTo('App\SubCategory', 'sub_category_id');
    }
    public function offer()
    {
        return $this->hasOne('App\ProductOffer', 'product_id');
    }

    public function store()
    {
        return $this->belongsTo('App\Store', 'store_id');
    }

}

app/Http/Controllers/Website/ProductsController.php
<?php

namespace App\Http\Controllers\Website;

use App\Category;
use App\Http\Controllers\Controller;
use App\Http\Misc\Helpers\Filters;
use App\Product;
use App\ProductImage;
use App\Store;
use App\SubCategory;
use Illuminate\Http\Request;

class ProductsController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request,Product $product)
    {
        //
        $products = $product;

        $products = Filters::searchBy($products, ['name' => $request->query('name')]);
        $products=$products->where('status',Product::STATUS_ONLINE);
        if($request->has('price_min_range')&&$request->has('price_max_range')){
            $products=$products->whereBetween('price',[$request->price_min_range,$request->price_max_range]);
        }
        if ($request->has('category')) {

            $category=Category::where('id',$request->category)->first();
            $sub_categories=SubCategory::where('category_id',$category->id)->pluck('id');
            $products_categories =Product::whereIn('sub_category_id',$sub_categories)->get();
            $products=$products->whereIn('id',$products_categories)->orderBy('created_at','desc');

        }else{
            $products=$products;

        };
        if($request->has('store')){
             $products=$products->where('store_id',$request->store);
        }
        if($request->has('sub_category')){
            $products=$products->where('sub_category_id',$request->sub_category);
       }

        if ($request->query('filter') && $request->query('filter') != 'none') {
            if($request->query('filter')=="1"){
                $products=$products->orderBy('price','asc');
            }else if($request->query('filter')=="2"){
                $products=$products->orderBy('price','desc');

            }else if($request->query('filter')=="3"){
                $products=$products->orderBy('created_at','desc');

            }
        }
         $products=$products->paginate(8);
         $products_max_in_total=Product::orderBy('price','desc')->value('price');
         $products_min_in_total=Product::orderBy('price','asc')->value('price');
         return view('website.products.index',compact('products','products_max_in_total','products_min_in_total'));
    }
    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show(Request $request ,Product $product)
    {
        //
        $similars=Product::where('store_id',$product->store->id)->orderBy('created_at','desc')->where('status',Product::STATUS_ONLINE)->inRandomOrder()->get();
        $message ="This Item is not currently avaliable!";
        if ($product->status != Product::STATUS_ONLINE) return view('website.products.not_avaliable',compact('similars','message'));

        $product_images=ProductImage::where('product_id',$product->id)->limit(5)->get();
        return view('website.products.show',compact('product','similars','product_images'));

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }
    public function autocomplete(Request $request)
    {
        $datas = Product::where('status',Product::STATUS_ONLINE)->select("name")
        ->where("name","LIKE","%{$request->input('query')}%")
        ->get();
    $dataModified = array();
     foreach ($datas as $data)
     {
       $dataModified[] = $data->name;
     }

    return response()->json($dataModified);
        return response()->json($data);
    }
    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/products/index.blade.php
@extends('layouts.resource.index')
@section('title', 'All Products')

@section('search-filter')
    <!-- Search and Filters START-->
    <form class="form " action="{{ route('all_products' . '.index') }}" method="get">
        <div class="d-flex justify-content-between">
            <div class="p-2 flex-fill ">
                @include('layouts.includes.forms.form_text',['field' => ['name' => 'name', 'text' => 'User']])
                @include('layouts.includes.forms.form_text',['field' => ['name' => 'store_name', 'placeholder' => 'Search By Store Name..']])

            </div>
            <div class="p-2 row flex-fill">
                <div class=" col form-group">
                    <select name="status" class="custom-select">
                        <option value="0"  @if(request()->query('status') == '0') selected @endif>Status...</option>
                        <option value="1"  @if(request()->query('status') == '1') selected @endif>Online</option>
                        <option value="2"  @if(request()->query('status') == '2') selected @endif>InReview</option>
                        <option value="3" @if(request()->query('status') == '3') selected @endif>Rejected</option>
                        <option value="4" @if(request()->query('status') == '4') selected @endif>Offline</option>
                        <option value="5" @if(request()->query('status') == '5') selected @endif>Draft</option>

                    </select>
                </div>
                <div class="col form-group ">
                <select class="custom-select" name="sub_category">
                    <option value="none" @if(request()->query('sub_category') == 'none') selected @endif>Sub Category...</option>
                    @foreach ($subCategories as $sub_category)
                    <option value={{$sub_category->id}}
                 @if(request()->query('sub_category') == $sub_category->id) selected @endif>{{$sub_category->name}} </option>
                    @endforeach
                </select>
                </div>

            </div>
            <div class="p-2 flex-fill ">
                <button type="submit" class="btn btn-block bg-blue mb-2">Filter</button>
            </div>
            <a href="{{ route('all_products'. '.index') }}" class="small-header-bold"> X</a>
        </div>
    </form>
    <!-- Search and Filters END-->
@endsection

@section('table-body')

@section('table-header')

        <th scope="col">@sortablelink('id', '#')</th>
        <th scope="col">Image</th>
        <th scope="col">@sortablelink('name','Product')</th>
        <th scope="col">@sortablelink('store_id','Store')</th>
        <th scope="col">@sortablelink('sub_catogrey_id','SubCategory')</th>
        <th scope="col">@sortablelink('price','Price')</th>
        {{-- <th scope="col">Visits</th> --}}
        <th scope="col">@sortablelink('ordered','Ordered')</th>
        <th scope="col">@sortablelink('stock','In Stock')</th>
        <th scope="col">@sortablelink('status','Status')</th>
        <th scope="col">@sortablelink('rate','Rate')</th>
        <th scope="col">@sortablelink('created_at','Created at') </th>
        <th scope="col">Operations </th>
@endsection
@section('table-body')
@foreach($products as $product)
<!------------------------------------------------------------- Rows START---------------------------------------------------------------------------->


<td>{{ $product->id }}</td>
<td><img src={{$product->image}} class="pp-square"></td>
<td>{{ Str::limit($product->name ,70) }} </td>
<td>{{ Str::limit($product->store->name ,70) }} </td>
<td>{{ $product->sub_category->name }}  </td>
<td>{{ $product->price }} EGP </td>
{{-- <td>{{ $product->visited }} </td> --}}
<td>{{ $product->ordered }} </td>
<td>{{ $product->stock }} </td>

<td>
    @if ($product->status == 1)
    <span class="badge badge-success text-white">Online</span>
    @elseif ($product->status == 2)
    <span class="badge badge-primary text-black">InReview</span>
    @elseif ($product->status == 3)
    <span class="badge badge-danger text-white">Rejected</span>
    @elseif ($product->status == 4)
    <span class="badge bg-grey  ">Offline</span>
    @elseif ($product->status == 5)
    <span class="badge bg-grey text-black">Draft</span>
    @else
    <span class="badge bg-grey text-black">Not determined</span>
    @endif
</td>
<td>
    @for($j = 0; $j < $product->rate; $j++)
        <span class="fa fa-star checked"></span>
    @endfor
    @for($j = 0; $j < (5-$product->rate); $j++)
        <span class="fa fa-star" style="color:grey;"></span>
    @endfor
</td>
<td>{{Carbon\Carbon::parse($product->created_at)->diffForHumans()}}</td>

<!------------------------------------------------------------- Rows START---------------------------------------------------------------------------->

<td class="d-flex justify-content-center"><a href="{{ route('products.show',[$product->store->id, $product->id]) }}"
    class="btn clr-black  "><i class="fas fa-eye"></i></a>
   <a href="{{ route('products.edit', [$product->store->id, $product->id]) }}"
     class="btn clr-black "><i class="fas fa-edit"></i></a>
       <form method="POST" action="{{ route('products.'.'destroy',[$product->store->id, $product->id]) }}">
           {{ csrf_field() }}
           {{ method_field('DELETE') }}
           <button type="submit"
            onclick="return confirm('Are you sure you want to delete this product?')"
            data-toggle="modal" data-target="#exampleModal"
       class="btn  clr-blue  bg-transparent"><i class="fas fa-trash-alt "></i></button>
       </form>
   </td>
</tr>
@endforeach
@endsection
    {{ $data->appends(request()->query())->links() }}
@section('table-footer')
<p class="table-footer">Results :  {{$data->total()}}</p>

@endsection
@endsection